<?php

# Importer ces fichiers dans avant l'appel de le class dans votre ficher appelleur.
//require_once(DOL_DOCUMENT_ROOT."/societe.class.php");
//require_once(DOL_DOCUMENT_ROOT."/../htdocs/importcsv/ImportCsvProfil.class.php");


class ImportCsv //extends Importcsv_profil
{
	var $File;
	var $Countligne;
	var $Ligne;
	var $Log;
	var $Limit;
	var $Html;
	var $PostVar;
	var $LiaisonFormSelect;
	var $LiaisonFormValue;
	var $LiaisonCsv;
	var $ProfilSauvegarde;
	var $Count;



	/*****************************************************************
	 *
	 * Vérifie si le fichier est present sur le serveur
	 * quand $File renseigne
	 *
	 *****************************************************************/

	function ImportCsv(){
		// On verifie si le fichier existe sur le disque dur
		if( isset($File) && !empty($File)){

			if ( !file_exists($File) ){
				dol_syslog('ImportCsv::ImortCsv File not detect');
				$this->Log = 'Le fichier '.$File.' est pas present sur le serveur.';
				return false;
			}else{
				return true;
			}
		}
		return true;

	} // fin importcsv


	/*****************************************************************
	 *
	 * Fonction qui retourne les valeurs d un fichier csv
	 * en variable tableau $this->Ligne[$ligne][$colonne]
	 * $File le fichier avec son chemin
	 * $Limit nombre de limit max (0 si pas de limit)
	 *
	 *****************************************************************/
	function CsvToArray($File, $Limit){

		if ( !isset($File) or empty($File)){
			$this->Log = 'Log F CsvToArray : variable File non existant ou vide';
			return false;
		}elseif( !isset($Limit) or empty($Limit)){
			$this->Log = 'Log F CsvToArray : varaible Limit non existant ou vide';
			return false;
		}

		$this->File		= $File;
		$this->Limit	= $Limit;

		if ( !$handle = fopen($this->File, "r") ){
			$this->Log = 'Ouverture du fichier '.$this->File.' impossible';
			return false;
		}

		$i=0;
		$this->Ligne = Array();
		while (($data = fgetcsv($handle, 1000, ";")) !== FALSE) {
			$num = count($data);
			$row++;
				
			// On stop la lecture si une limite a ete renseigne
			if ( $this->Limit != 0 ){
				if ( $i >= $this->Limit ){
					$this->Log = 'break effectue au '.$i."<br />\n";
					$this->Log.= 'Limite parametrer sur '.$this->Limit."<br />\n";
					break 1;
				}
			}
				
			/*
			 * On met le fichier CSV en variable tableau
			 * $i = ligne csv
			 * $c = colonne / champ csv
			 */
			for ($c=0; $c < $num; $c++) {

				$data[$c] = convToUtf8($data[$c]);
				## On supprime les accents et minuscule des titres csv
				if ( $i == 0 ){
					$data[$c] = filter($data[$c]); // Supprime accent
					$data[$c] = strtolower($data[$c]); // tout en minuscule
				}
				$this->Ligne[$i][$c] = trim($data[$c]);
			}

			$i++;
		}
		$this->Count = $i;
		dol_syslog('ImportCsv::CsvToArray Read nbr row='.$this->Count);

		if ( !fclose($handle) ){
			$this->Log = 'Impossible de fermer le fichier';
			dol_syslog('ImportCsv::CsvToArray error open file not possible');
			return false;
		}else{
			$this->Log = $File;
			return true;
		}

	} // Fin fonction listcsv



	/*****************************************************************
	 *
	 * Affiche dans un tableau html un fichier csv
	 *
	 * $File = le fichier avec son chemin
	 * $Limit = le nombre de ligne a afficher, 0 pour toutes les lignes
	 *
	 * $FormAction = page.php du formulaire, 0 si pas de form
	 * $FormMethode = methode ex : post, 0 si pas de form
	 *
	 * $SelectChoix = code html de formulaire select, ex :
	 * $SelectChoix = '<option value="noselect">-- Fiche </option>';
	 *
	 * ****************************************************************/

	function CsvToHtml($File, $Limit, $FormAction, $FormMethode, $SelectChoix){
		$this->File	 = $File;
		$this->Limit = $Limit;
		$this->Html  = '';

		$ListerCsv = New ImportCsv;
		if ( !$ListerCsv->CsvToArray($this->File, $this->Limit) ){
			$this->Log = "Probleme pendant l utilisation de la fonction ListCsv.<br/>\n";
			$this->Log.= 'Log de ListCsv : '.$ListerCsv->Log."<br />\n";
			return false;
		}

		// Début de formulaire
		if (
		isset($FormAction) && !empty($FormAction) &&
		isset($FormMethode) && !empty($FormMethode) &&
		isset($SelectChoix) && !empty($SelectChoix)
		)
		{
			$this->Html.= "<!-- Begin form conf_import -->\n";
			$this->Html.= '<form action="'.$FormAction.'" method="'.$FormMethode."\">\n";
		}


		// On passe ligne par ligne le fichier CSV
		$pos='h';
			if ( $pos == 'h' or !isset($pos) or empty($pos)){
			$i=0;
			$this->Html.= "<table border=\"1\" cellpadding=\"1\" cellspacing=\"2\">\n";
			foreach ( $ListerCsv->Ligne as $LigneCsv ){

				// Mettre en valeur la premiere ligne
				if ( $i == 0 ){
					$TitreCsv1 = '<b>';
					$TitreCsv2 = '</b>';
				}else{
					$TitreCsv1 = '';
					$TitreCsv2 = '';
				}

				// On affiche le contenu des champs CSV
				$this->Html.= "\t<tr>\n";
				$j=0;
				
				// On affiche les selects form
				if (
				$i == 0 &&
				isset($FormAction)  && !empty($FormAction) &&
				isset($FormMethode) && !empty($FormMethode) &&
				isset($SelectChoix) && !empty($SelectChoix)
				)
				{
					$this->Html.= "<tr>\n";
					foreach ( $LigneCsv as $Col ){
						//resultat	de select
						$this->Html.= "\t\t<td>";
						//$this->Html.= '<select name="'.htmlentities($Col,ENT_QUOTES).'">';
						$this->Html.= '<select name="'.strtolower($Col).'">';
						$this->Html.= strtolower($SelectChoix);
						$this->Html.="</select>\n";
						$this->Html.= "\t\t</td>\n";
					}
					$this->Html.="</tr>\n";
				}
				
				// affiche les valeurs des champs csv
				foreach ( $LigneCsv as $Col ){
					$this->Html.= "\t\t<td>".$TitreCsv1.$Col.$TitreCsv2."</td>\n";
					$j++;
				}
				
				$this->Html.= "\t</tr>\n";
				$i++;
			}
			$this->Html.= "</table>\n";
		}
		
		// Fin du formulaire
		if (
		isset($FormAction) && !empty($FormAction) &&
		isset($FormMethode) && !empty($FormMethode) &&
		isset($SelectChoix) && !empty($SelectChoix)
		)
		{
			$this->Html.= '<label>';
			$this->Html.= '<input name="profilimport" type="text" id="profilimport" value="" size="30" />';
			$this->Html.= "<label>\n";
			$this->Html.= '<label>';
			$this->Html.= '<input type="submit" name="envoyer" id="envoyer" value="Envoyer" />';
			$this->Html.= "</label>\n";
			$this->Html.= "</form>\n";
			$this->Html.= "<!-- End form conf_import -->\n";
		}
		return true;
	}

	/*****************************************************************
	 *
	 * Récupère les clefs et valeur de la variables $_POST
	 * Et la met en variable tableau $this->PostVar[$clef][$valeur]
	 * $this->PostVar[0][$i] = $key  'form select'
	 * $this->PostVar[1][$i] = $val  'from valeur'
	 *
	 * ****************************************************************
	 */

	function PostToArray($VarPost){
		unset($this->PostVar);

		//On recupere le nom du profil d import
		if ( isset($_POST['profilimport']) && !empty($_POST['profilimport'])){
			$this->ProfilSauvegarde = $_POST['profilimport'];
		}else{
			$this->Log = 'fonction PostTo Array : Impossible de recuperer le nom du profil a sauvegarder';
			return false;
		}

		$i=0;
		$FDoublon = array();
		reset($_POST);
		while (list($key, $val) = each($_POST)) {

			//On recupére que les champs sélectionner
			if ( $val != 'noselect' && $key!='envoyer' &&
			$key != 'profilimport' &&
			isset($key) 		&& !empty($key) &&
			isset($val) 		&& !empty($val))
			{
					
				// On vérifie les doublons
				$j=0;
				while ( isset($ValueNd[$j]) && !empty($ValueNd[$j]) ){
					if ( $ValueNd[$j] == $val ){
						//Doublon d�tecter on stop la proc�dure
						$this->Log = '<br />Doublon detecter sur "'.$val."\" , procedure annuler.<br />\n";
						return false;
					}
					$j++;
				}
				$this->PostVar[0][$i] = $key; // valeur csv
				$this->PostVar[1][$i] = $val; // valeur form
					
				$i++;
			}// Fin if champ select
		} // Fin while _POST
		return true;
	} // Fin fonction PostToArray



	/*****************************************************************
	 *
	 * Met en relation le formulaire sélectionné avec le fichier csv
	 * $VarPost ( y inséré $_POST )
	 * $File ( le ficier.zip avec son chemin )
	 * $Type ( filtre, ex : $Type = 1, filtrera que les fournisseurs )
	 *
	 * retourne :
	 * $this->LiaisonFormSelect[$Colonne] 	// Formulaire selectionne
	 * $this->LiaisonFormValue[$Colonne]  	// Valeur du formulaire
	 * $this->LiaisonCsv[$Ligne][$Colonne]	// Valeur du champ CSV
	 *
	 * ***************************************************************/


	function LiasonPostCsvArray($VarPost,$File, $Type, $Limit){

		/*
		 * On test les variables d'entree
		 */
		if( !isset($VarPost) or empty($VarPost)){
			dol_syslog('ImportCsv::LiaisonPostCsvArray error var post');
			$this->Log = 'Class ImportCsv, function LiaisonPostCsvArray erreur variable non presente.';
			return false;
		}

		if ( !isset($File) or empty($File)){
			dol_syslog('ImportCsv::LiaisonPostCsvArray error var file');
			$this->Log = 'Class ImportCsv, function LiaisonPostCsvArray erreur pendant la recuperation de la variable File.';
			return false;
		}


		/*
		 * On recupere fichier csv en variable tableau
		 */
		$TraitementCsv = New ImportCsv;
		if ( !$TraitementCsv->CsvToArray($File, $Limit) ){
			dol_syslog('ImportCsv::LiaisonPostCsvArray error on declar objet TraitementCsv->CsvToArray');
		}


		/*
		 * On met $_POST en variable tableau
		 */
		$GenTabHtml = New ImportCsv;

		//On recupere le nom du profil de sauvegarde
		$this->ProfilSauvegarde = $GenTabHtml->ProfilSauvegarde;

		if( !$GenTabHtml->PostToArray($Varpost) ){
			$this->Log = 'Class ImportCsv, function LiaisonPostCsvArray erreur sur PostToArray<br />';
			$this->Log.= $GenTabHtml->Log."<br />\n";
			dol_syslog('ImportCsv::LiaisonPostCsvArray error getting var Post.');
			return false;
		}

		/*
		 * On traite le tableau csv pour n afficher que les valeurs selectionnees
		 */

		$PositionColonneType = 8; // a automatiser /!\

		// Lecture ligne valeurs CSV
		$i=0; $k=0;
		while ( isset($TraitementCsv->Ligne[$i][0]) ){
			$j=0;
				
			// Lecture colonne valeurs CSV ligne en cour
			while ( isset($TraitementCsv->Ligne[$i][$j]) ){

				// Detect lisaison 'formulaire selectionner' et 'titre du fichier d import'
				if ( $GenTabHtml->PostVar[0][$i] == $TraitementCsv->Ligne[0][$j]){
						
					// liaison formulaire
					$this->LiaisonFormSelect[$k]	= $GenTabHtml->PostVar[0][$i];	// selection form
					$this->LiaisonFormValue[$k]		= $GenTabHtml->PostVar[1][$i];	// Valeur form
						
					// liaison donnees csv
					$l=0; $m=0;
					while (isset($TraitementCsv->Ligne[$l][$j])){

						// alimente valeurs voulu
						if ( $TraitementCsv->Ligne[$l][$PositionColonneType] == $Type ){
							$this->LiaisonCsv[$m][$k] = $TraitementCsv->Ligne[$l][$j];	// Valeur CSV selectionne
							$m++;
						}
						// alimente toute donnees si articles
						elseif( $Type == 'catproduct'){
							$this->LiaisonCsv[$m][$k] = $TraitementCsv->Ligne[$l][$j];	// Valeur CSV selectionne
							$m++;
						}

						$l++;
					} // Fin liaison donnes csv
					$k++;
					break 1;
				} // Fin detetection liaison
				$j++;
			} // Fin lecture des colonnes
			$i++;
		} // Fin lecture ligne valeur CSV


		// Nbr liaison effectuer
		if ( $k == 0 ){
			dol_syslog('ImportCsv::LiaisonPostCsvArray error no make liaison');
		}else{
			dol_syslog('importCsv::LiaisonPostCsvArray info make liaison='.$k);
		}

		return true;
	}

	/*****************************************************************
	 *
	 * Recupere les clefs et valeur de la variables $_POST
	 * et en génère un tableau html dans $this->Html
	 * $VarPost insere $_POST
	 * $File le fichier avec son chemin
	 *
	 * ****************************************************************/

	function PostToHtml($VarPost,$File,$Type,$Limit){

		## On test les variables d'entree
		if( !isset($VarPost) or empty($VarPost)){
			dol_syslog('ImportCsv::PostToHtml error no var post');
			$this->Log = 'Class ImportCsv, function PostToHtml erreur variable non presente.';
			return false;
		}

		if ( !isset($File) or empty($File)){
			dol_syslog('ImportCsv::PostToHtml error no var file');
			$this->Log = 'Class ImportCsv, function PostToHtml erreur pendant la recuperation de la variable File.';
			return false;
		}{
			dol_syslog('ImportCsv::PostToHtml var file='.$File);
		}

		## On recupere les valeurs du formulaire selectioner joint au fichier csv
		$LiaisonPostToCsv = New ImportCsv();
		$LiaisonPostToCsv->LiasonPostCsvArray($VarPost,$File, $Type, $Limit);
		$this->Html = '';
		if ( $pos == 'h' or !isset($pos) or empty($pos)){
			## On genere le HTML			
			$this->Html.= "<table border=\"1\">\n";
			$this->Html.= "<tr>\n";
			$this->Html.= "<td><b>valeur import</b></td>\n";
			$this->Html.= "<td>&nbsp;</td>\n";
			$this->Html.= "<td><b>valeur dolibarr</b></td>";
			$this->Html.= "<td>&nbsp;</td>\n";

			// On genere les colonnes du tableau html
			$i = 0;
			while ( isset($LiaisonPostToCsv->LiaisonCsv[$i][0])){
				$this->Html.= "<td align=\"center\"><b>".$i."</b></td>";
				$i++;
			}
			$this->Html.= "</tr>\n";

			// On calcul le nombre de ligne des elements du fichier a importer
			if ( $i == 0 ){
				dol_syslog('ImportCsv::PostToHtml error no row liaision read type='.$Type.' limit='.$Limit);
			}else{
				dol_syslog('ImportCsv::PostToHtml info row liaison read='.$i.' type='.$Type.' limit='.$Limit);
			}

			// On genere les lignes du tableau html
			$i=0;
			while ( isset($LiaisonPostToCsv->LiaisonFormSelect[$i]) ){
				$this->Html.= "<tr>\n";
				$this->Html.= '<td>';

				// Affiche le formulaire selectionne
				if ( !empty($LiaisonPostToCsv->LiaisonFormSelect[$i]) ){
					$this->Html.= $LiaisonPostToCsv->LiaisonFormSelect[$i];
				}else{
					$this->Html.= '&nbsp;';
				}
				$this->Html.="</td>\n";
				$this->Html.= "<td>-></td>\n";
				$this->Html.= '<td>';
				
				// Affiche la valeur du formulaire selectionne
				if ( !empty($LiaisonPostToCsv->LiaisonFormValue[$i])){
					$this->Html.= $LiaisonPostToCsv->LiaisonFormValue[$i];
				}else{
					$this->Html.= '&nbsp;';
				}
				
				$this->Html.= "</td>\n";
				$this->Html.= "<td>-></td>\n";
					
				// Affiche la valeur csv selectionner
				$k=0; $l = 0;
				
				while ( isset($LiaisonPostToCsv->LiaisonCsv[$k][$i])){

					// On gre la couleur une fois sur deux
					if ( $l == 1 ){
						$couleur = '';
						$l=0;
					}else{
						$couleur = 'bgcolor="#DDDDDD"';
						$l=1;
					}

					$this->Html.= '<td '.$couleur.'>';
					if ( !empty($LiaisonPostToCsv->LiaisonCsv[$k][$i]) ){
						$this->Html.= $LiaisonPostToCsv->LiaisonCsv[$k][$i];
					}else{
						$this->Html.= '&nbsp;';
					}
					$this->Html.= "</td>\n";
					$k++;
				}
				
				$this->Html.= "</tr>\n";

				$i++;
			}
			$this->Html.= "</table>\n";
			$this->Html.= "<br />\n";
		}
		
	return true;

	} // Fin fonction PostTohtml

	/*****************************************
	 *
	 * Sauvegarde le profil d'importation
	 * En cours dev
	 *
	 * ***************************************/

	function SauvegardeProfil($VarPost,$FileCsv,$user,$db){

		## On test les variables d entre
		if ( !isset($VarPost) or empty($VarPost)){
			$this->Log = 'Erreur fonction SauvegardeProfil : Impossible de recuperer les variables du formulaire poster.';
			return false;
		}

		$LiaisonASauvegarder = New ImportCsv();
		if (!$LiaisonASauvegarder->PostToArray($VarPost)){
			$this->Log = "Erreur fonction SauvegardeProfil a l appel de la fonction LiasonPostCsvArray.<br />\n";
			$this->Log.= 'Erreur retourner par LiaisonPostCsvArray : '.$LiaisonASauvegarder->Log;
			return false;
		}

		// On recupere le nom du profil d'import a sauvegarder
		$this->ProfilSauvegarde = $LiaisonASauvegarder->ProfilSauvegarde;

		$SqlProfil = New Importcsv_profil($db);

		//*
		$i=0;
		$this->Html = '';
		while ( $LiaisonASauvegarder->PostVar[0][$i] ){

			$SqlProfil->name_profil	= $this->ProfilSauvegarde;
			$SqlProfil->formselect	= $LiaisonASauvegarder->PostVar[0][$i];
			$SqlProfil->formvalue	= $LiaisonASauvegarder->PostVar[1][$i];
			$SqlProfil->filecsv		= $FileCsv;
			$SqlProfil->create($user);

			$i++;
		}
		//*/
		return true;
	}

	/******************************************************************************
	 *
	 * 			PERMET INSERTION CATEGORIE POUR UN CLIENT OU FOURNISSEUR
	 *
	 * Objet 					// Objet societe ou client
	 * NomCategorie 			// Le nom de la categorie a faire joindre
	 * TypeNum					// 1 pour fournisseur ou 0 pour client
	 * TypeAlpha				// 'fournisseur' ou 'client'
	 * ex : JoindreCategorieSociete($soc,'web',1,'fournisseur',$db,$user);
	 *
	 * ********************************************************************************/


	function JoindreCategorieSociete($Objet,$NomCategorie,$TypeNum,$TypeAlpha,$db,$user){

		if ( $TypeNum == 0 ){
			$TypeNum = 2; // Type client
			$TypeAlpha = 'societe';
		}

		// recherche id cat par rapport a son nom
		$cat = new Categorie($db);
		$resultSearch = $cat->rechercher('', $NomCategorie, $TypeNum, $exact = true);
	 	
		$cat->id = $resultSearch[0]->id;
		 
		// insertion categorie
		$result = $Objet->fetch($Objet->id,$user);
		$result = $cat->fetch($cat->id);
		$result = $cat->add_type($Objet, $TypeAlpha);
		 
		if ( !$result ){
			dol_syslog('ImportCsv::JoindreCategorieSociete, Erreur pendant insertion categorie : '.$Objet->nom.' : '.$NomCategorie);
			return false;
		}else{
			dol_syslog('ImportCsv::JoindreCategorieSociete, Insertion Categorie Success  : '.$Objet->nom.' : '.$NomCategorie);
		}
		return true;
	}

	/****************************************************
	 *
	 * PERMET INSERTION FOURNISSEUR AVEC CES CATEGORIES
	 *
	 *
	 * ***************************************************/

	function InsertFournisseur($VarPost,$File,$Type,$TypeAlpha,$Limit,$db){
		$soc = New Societe($db);
		$this->Html = '';
		## On test les variables d'entree

		if( !isset($VarPost) or empty($VarPost)){
			dol_syslog("ImportCsv::InsertFournisseur erreur variable VarPost non presente");
			$this->Log = 'Class ImportCsv, function PostToHtml erreur variable non presente.';
			return false;
		}

		if ( !isset($File) or empty($File)){
			dol_syslog("ImportCsv::InsertFournisseur erreur variable File non presente");
			$this->Log = 'Class ImportCsv, function PostToHtml erreur pendant la recuperation de la variable File.';
			return false;
		}

		## On recupere les valeurs du formulaire selectioner joint au fichier csv
		$LiaisonPostToCsv = New ImportCsv();
		$LiaisonPostToCsv->LiasonPostCsvArray($VarPost,$File, $Type, $Limit);

		## Insertion societe dans la base
		$i=0;
		while ( isset($LiaisonPostToCsv->LiaisonCsv[$i][0])){
			$ImportSociete[$i] = New Societe($db);
			$categorie[$i] = 0;
			$j=0;
			while ( isset($LiaisonPostToCsv->LiaisonCsv[$i][$j])){
					
				//On repere la colonne des categories
				if ( $LiaisonPostToCsv->LiaisonFormValue[$j] == 'categorie'){
					$ColonneCategorie[$i] = $j;
				}
					
				## quelques filtres =)
				$LiaisonPostToCsv->LiaisonCsv[$i][$j] = trim($LiaisonPostToCsv->LiaisonCsv[$i][$j]);
					
				// On converti en nombre entier le code postal
				if ( $LiaisonPostToCsv->LiaisonFormValue[$j] == 'cp'){
					$LiaisonPostToCsv->LiaisonCsv[$i][$j] = str_replace(' ','',$LiaisonPostToCsv->LiaisonCsv[$i][$j]);
					$LiaisonPostToCsv->LiaisonCsv[$i][$j] = intval($LiaisonPostToCsv->LiaisonCsv[$i][$j]);
				}
					
				// On recupere la categorie pour ce fournisseur si possible
				if ( $LiaisonPostToCsv->LiaisonFormValue[$j] == 'categorie'){
					$categorie[$i] = strtolower($LiaisonPostToCsv->LiaisonCsv[$i][$j]);
					dol_syslog('ImportCsv::InsertFournisseur Categorie : '.$categorie[$i]);
				}else{
					## On fait le lien entre la valeur CSV et les propriete de l'objet societe
					$ImportSociete[$i]->{$LiaisonPostToCsv->LiaisonFormValue[$j]} = $LiaisonPostToCsv->LiaisonCsv[$i][$j];
					dol_syslog('ImportCsv::InsertFournisseur Liaison_CSV_Dolibarr = '.$LiaisonPostToCsv->LiaisonFormSelect[$j].' : '.$LiaisonPostToCsv->LiaisonFormValue[$j].' : '.$LiaisonPostToCsv->LiaisonCsv[$i][$j]);
				}
				$j++;
			}

			## On applique l insertion de la societe

			if ( $Type == 0 ){ // type client
				$ImportSociete[$i]->client = 1;
				$ImportSociete[$i]->fournisseur = 0;
			}elseif ( $Type == 1 ){ // type fournisseur
				$ImportSociete[$i]->client = 0;
				$ImportSociete[$i]->fournisseur = 1;
			}else{
				dol_syslog('ImportCsv::InsertFournisseur Erreur sur la variable type');
				return false;
			}

			if ( $ImportSociete[$i]->fournisseur == 1 or $ImportSociete[$i]->client == 1 &&	$ImportSociete[$i]->nom != 'nom'){
				if (!$ImportSociete[$i]->create($user)){
					dol_syslog('ImportCsv::InsertFournisseur sur creation a la ligne '.$LiaisonPostToCsv->LiaisonCsv[$i][$j]);
				}

				// On insert la categorie du fournisseur si existante
				if ( !empty($categorie[$i]) ){

					if (!$LiaisonPostToCsv->JoindreCategorieSociete($ImportSociete[$i],$categorie[$i],$ImportSociete[$i]->fournisseur,$TypeAlpha,$db,$user)){
						dol_syslog('ImportCsv::InsertFournisseur, Erreur pendant insertion categorie : '.$ImportSociete[$i]->nom);
					}

				}else{
					dol_syslog('ImportCsv::InsertFournisseur, No categorie for : '.$ImportSociete[$i]->nom);
				}
			}
			dol_syslog('ImportCsv::InsertFournisseur ------------------- N '.$i.' [terminer]');
			$i++;
		}
		dol_syslog("ImportCsv::InsertFournisseur Success");
		return true;
	}

	function InsertCategorie($VarPost,$File,$Type,$TypeAlpha,$Limit,$db){

		$this->Html = '';
		## On test les variables d'entree
		if( !isset($VarPost) or empty($VarPost)){
			dol_syslog("ImportCsv::InsertCategorie erreur variable VarPost non presente");
			$this->Log = 'Class ImportCsv, function InsertCategorie erreur variable non presente.';
			return false;
		}

		if ( !isset($File) or empty($File)){
			dol_syslog("ImportCsv::InsertCategorie erreur variable File non presente");
			$this->Log = 'Class ImportCsv, function InsertCategorie erreur pendant la recuperation de la variable File.';
			return false;
		}

		// On recupere les correspondances entre le formulaire slectionner et le fichier
		$LiaisonPostToCsv = New ImportCsv();
		if ( !$LiaisonPostToCsv->LiasonPostCsvArray($VarPost,$File, $Type, $Limit) ){
			dol_syslog("ImportCsv::InsertCategorie erreur sur fonction LiaisonPostCsv");
			$this->Log = 'Class ImportCsv, function InsertCategorie sur fonction LiaisonPostCsv.';
			return false;
		}

		// On verifie si on doit joindre des categories mere.
		$i=0;
		foreach ($LiaisonPostToCsv->LiaisonFormValue as $valeur){
			if ( $valeur == 'nom_mere' ){
				$this->Html.= "nom mere est active <br />\n";
				$InsertionNomMere = 1;
				$PositionArrayNomMere = $i;
				dol_syslog("ImportCsv::InsertCategorie Nom mere detecter");
				break 1;
			}
			$i++;
		}

		//Ajout des categories ligne par ligne
		$i=0;
		while ( isset($LiaisonPostToCsv->LiaisonCsv[$i][0])){
			$cat[$i] = New Categorie($db);
			$cat[$i]->type = 0;
			$cat[$i]->visible = 1;


			// On recherche l id de la categorie mere existante
			if ( $InsertionNomMere == 1 && !empty($LiaisonPostToCsv->LiaisonCsv[$i][$PositionArrayNomMere]) ){

				$NomCategorie[$i] = $LiaisonPostToCsv->LiaisonCsv[$i][$PositionArrayNomMere];
					
				// recherche id cat par rapport a son nom
				$catSearch = new Categorie($db);
				$resultSearch = $catSearch->rechercher('', $NomCategorie[$i], 0, $exact = true);
				$cat[$i]->id_mere = $resultSearch[0]->id;
			}

			// On fait le lien entre la valeur CSV et les propriete de l'objet categorie
			$j=0;
			while ( isset($LiaisonPostToCsv->LiaisonFormValue[$j])){
				$cat[$i]->{$LiaisonPostToCsv->LiaisonFormValue[$j]} = $LiaisonPostToCsv->LiaisonCsv[$i][$j];
				dol_syslog('ImportCsv::InsertCategorie Liaison_CSV_ObjetCat = '.$LiaisonPostToCsv->LiaisonFormSelect[$j].' : '.$LiaisonPostToCsv->LiaisonFormValue[$j].' : '.$LiaisonPostToCsv->LiaisonCsv[$i][$j]);
				$j++;
			}
				
			// On creer la categorie
			$cat[$i]->create();
				
			$i++;
		}

		return true;
	}

	/**************************************
	 *
	 * Insertion d article
	 *
	 * ***********************************/

	function InsertArticle($VarPost,$File,$Type,$Limit,$db,$user){
		
		/*
		 * test var entree
		 */
		
		if ( !isset($VarPost) or empty($VarPost)){
			$log = 'ImportCsv:InsertArticle error var post';
			dol_syslog($log);
			$this->Log = $log;
			return false;
		}
		
		if ( !isset($File) or empty($File)){
			$log = 'ImportCsv:InsertArticle error var file';
			dol_syslog($Log);
			$this->Log = $log;
			return false;
		}else{
			dol_syslog('ImportCsv:InsertArticle file='.$File);
		}
		
		/*
		 * Correspondance formulaire <-> fichier CSV
		 */
		
		$LiaisonArticle = New ImportCsv();
		$LiaisonArticle->LiasonPostCsvArray($VarPost,$File, $Type, $Limit);
		
		/*
		 * Ajout articles base
		 */
		
		// Lecture ligne liaison
		$i=0;
		while ( isset($LiaisonArticle->LiaisonCsv[$i][0])){
			$Article[$i] = New Product($db);
			
			/*
			 * Lien valeur CSV et propriete objet Article
			 */
			
			// On saute les titres
			$j=0;
			if ( $LiaisonArticle->LiaisonFormValue[$i] != $LiaisonArticle->LiaisonCsv[$i][0] ){				
				while ( isset($LiaisonArticle->LiaisonFormValue[$j])){
					$Article[$i]->finished = 1;
					$Article[$i]->price_base_type = 'TTC';
					$Article[$i]->status = 1;
					$Article[$i]->type = 0;
					//$Article[$i]->tva_tx = '19.6';
					str_replace(',','.',$LiaisonArticle->LiaisonCsv[$i][$j]);			
					$Article[$i]->{$LiaisonArticle->LiaisonFormValue[$j]} = $LiaisonArticle->LiaisonCsv[$i][$j];
					dol_syslog('ImportCsv::InsertArticle Liaison_CSV_ObjetArticle = '.$LiaisonArticle->LiaisonFormSelect[$j].' : '.$LiaisonArticle->LiaisonFormValue[$j].' : '.$LiaisonArticle->LiaisonCsv[$i][$j]);
					$j++;
				}
			}
			
			/*
			 *  On creer l article
			 */
			
			// On saute les titres csv
			if ( $LiaisonArticle->LiaisonFormSelect[$i] != $LiaisonArticle->LiaisonCsv[$i][0] ){
				// creation
				if( !$Article[$i]->create($user)){
					dol_syslog('ImportCsv::InsertArticle error create article');
				}
			}
			
			$i++;
		}	
		
		if ( $i == 0 ){
			dol_syslog('ImportCsv::InsertArticle error not article liaison');
		}
		
		return true;
	}

	/*****************************************************************
	 *
	 * Initialise les variables de la class
	 *
	 *****************************************************************/

	function Init(){
		$this->File = '';
		$this->Countligne = '';
		$this->Ligne = '';
		$this->Log = '';
		$this->Limit = '';
		$this->Html = '';
		$this->PostVar = '';
		$this->ProfilSauvegarde = '';
		$this->Count = '';
	}// Fin Init

} // fin class

?>