<?php
/* Copyright (C) 2007 Laurent Destailleur  <eldy@users.sourceforge.net>
 * Copyright (C) ---Put here your own copyright and developer email---
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/**
 *   	\file       dev/skeletons/skeleton_page.php
 *		\ingroup    mymodule othermodule1 othermodule2
 *		\brief      This file is an example of a php page
 *		\version    $Id: skeleton_page.php,v 1.8 2009/03/09 11:28:12 eldy Exp $
 *		\author		Put author name here
 *		\remarks	Put here some comments
 */
require("./pre.inc.php");
require_once(DOL_DOCUMENT_ROOT."/../dev/skeletons/skeleton_class.class.php");
require_once(DOL_DOCUMENT_ROOT."/importcsv/ImportCsv.class.php");
require_once(DOL_DOCUMENT_ROOT."/importcsv/fonction_divers.php");
require_once(DOL_DOCUMENT_ROOT."/categories/categorie.class.php");

// Load traductions files requiredby by page
$langs->load("companies");
$langs->load("other");

// Get parameters
$myparam = isset($_GET["myparam"])?$_GET["myparam"]:'';

// Protection if external user
if ($user->societe_id > 0)
{
	//accessforbidden();
}



/*******************************************************************
* ACTIONS
*
* Put here all code to do according to value of "action" parameter
********************************************************************/




/***************************************************
* PAGE
*
* Put here all code to build page
****************************************************/

llxHeader('ImportCSV','','');
print_fiche_titre('Importation '.$_GET['type'].' 3 / 4');

// On recupere le fichier sélectionner précédament
if ( isset($_GET['archive']) && !empty($_GET['archive']) && isset($_GET['file']) && !empty($_GET['file'])){
	$Archive = $_GET['archive'];
	$File	 = $_GET['file'];
	echo '<br />Archive = '.$Archive.' | Fichier = '.$File;
}else{
	echo '<br />Erreur : Impossible de recuperer le fichier selectionner.';
	$db->close();
	llxFooter('$Date: 2009/03/09 11:28:12 $ - $Revision: 1.8 $');
	exit;	
}

$DossierTemp = DOL_DOCUMENT_ROOT.'/importcsv/temp';
$FileCsv = $DossierTemp.'/'.$Archive.'/'.$File;

echo '<br />chemin du fichier : '.$FileCsv."<br />\n";

if ( !$ImportCsv = New ImportCsv($File) ){
	echo '<br />Le fichier est pas reconnu sur le serveur.<br />';
	echo 'log : '.$ImportCsv->Log."<br />\n";
}

$FormSelect = '';

if( $_GET['type'] == 'fournisseur' or $_GET['type'] == 'client'){
	
	$FormSelect.= '<option value="noselect">-- [Societe] --</option>';
	$soc = New Societe($db);
	$SocVar = get_class_vars(get_class($soc));
	foreach ($SocVar as $name => $value){
		//echo $name." : ".$value."<br />\n";
		$FormSelect.= "<option value=\"".$name."\">".$name."</option>";
	}
	$FormSelect.= "<option value=\"categorie\">categorie</option>";
	
}elseif( $_GET['type'] == 'catproduct'){
	
	$FormSelect.= '<option value="noselect">-- [Categorie] --</option>';
	$cat = New Categorie($db);
	$CatVar = get_class_vars(get_class($cat));
	foreach ($CatVar as $name => $value){
		//echo $name." : ".$value."<br />\n";
		$FormSelect.= "<option value=\"".$name."\">".$name."</option>";
	}
	$FormSelect.= "<option value=\"nom_mere\">nom_mere</option>";
}elseif( $_GET['type'] == 'article'){
	$FormSelect.= "<option value=\"noselect\">--</option>\n";
	$FormSelect.= "<option value=\"noselect\">-- [information] --</option>\n";
	$FormSelect.= "<option value=\"ref\">ref_article</option>\n";
	$FormSelect.= "<option value=\"libelle\">libelle</option>\n";
	$FormSelect.= "<option value=\"description\">description</option>\n";
	$FormSelect.= "<option value=\"noselect\"></option>\n";
	$FormSelect.= "<option value=\"noselect\">-- [tarification] --</option>\n";
	$FormSelect.= "<option value=\"type\">type_ht_ttc</option>\n";
	$FormSelect.= "<option value=\"tva_tx\">taux_tva</option>\n";
	$FormSelect.= "<option value=\"price\">prix_vente_ht</option>\n";
	$FormSelect.= "<option value=\"price_ttc\">prix_vente_ttc</option>\n";
	$FormSelect.= "<option value=\"price_min\">prix_vente_min_ht</option>\n";
	$FormSelect.= "<option value=\"price_min_ttc\">prix_vente_min_ttc</option>\n";
	$FormSelect.= "<option value=\"noselect\"></option>\n";
	$FormSelect.= "<option value=\"noselect\">-- [Vente] --</option>\n";
	$FormSelect.= "<option value=\"envente\">En vente=1</option>\n";
	$FormSelect.= "<option value=\"horsvente\">Hors vente=1</option>";
	$FormSelect.= "<option value=\"noselect\"></option>\n";
	$FormSelect.= "<option value=\"noselect\">-- [Autre] --</option>\n";
	$FormSelect.= "<option value=\"code_fourn\">code_fournisseur</option>\n";
	$FormSelect.= "<option value=\"cat_name\">code_categorie</option>\n";
	$FormSelect.= "<option value=\"barcode\">codebar</option>\n";
	
	
	
	/*
	$product = New Product($db);
	$ProductVar = get_class_vars(get_class($product));
	foreach ($ProductVar as $name => $value){
		$FormSelect.= "<option value=\"".$name."\">".$name."</option>\n";
	}
	//*/
}

if ( !$ImportCsv->CsvToHtml($FileCsv, 20, 'importfournisseur4.php?type='.$_GET['type'].'&file='.$File.'&archive='.$Archive, 'post', $FormSelect) ){
	echo '<br />Erreur pendant la lecture du fichier '.$FileCsv."<br />\n";
	echo 'log : '.$ImportCsv->Log."<br />\n";
}

echo "On affiche le tableau csv to html.<br />\n";
echo $ImportCsv->Html;



// End of page
$db->close();
llxFooter('$Date: 2009/03/09 11:28:12 $ - $Revision: 1.8 $');
?>
